org.python.modules.jffi

## Class CodegenUtils

- java.lang.Object
- - org.python.modules.jffi.CodegenUtils

    public class CodegenUtils
    extends java.lang.Object

Author:
  headius

### Constructor Summary

Constructors
Constructor and Description
`CodegenUtils()`

### Method Summary

All Methods Static Methods Concrete Methods
`static java.lang.String` `c(java.lang.String p)` Creates a dotted class name from a path/package name
`static java.lang.String` `ci(java.lang.Class n)` Creates a class identifier of form Labc/abc;, from a Class.
`static java.lang.String` `getAnnotatedBindingClassName(java.lang.String javaMethodName, java.lang.String typeName, boolean isStatic, int required, int optional, boolean multi, boolean framed)`
`static java.lang.Class` `getBoxType(java.lang.Class type)`
`static java.lang.String` `human(java.lang.Class n)` Creates a human-readable representation, from a Class.
`static java.lang.String` `humanShort(java.lang.Class n)`
`static java.lang.String` `p(java.lang.Class n)` Creates a class path name, from a Class.
`static java.lang.Class[]` `params(java.lang.Class... classes)`
`static java.lang.Class[]` `params(java.lang.Class cls1, java.lang.Class cls2, java.lang.Class clsFill, int times)`
`static java.lang.Class[]` `params(java.lang.Class cls1, java.lang.Class clsFill, int times)`
`static java.lang.Class[]` `params(java.lang.Class cls, int times)`
`static java.lang.String` `pretty(java.lang.Class retval, java.lang.Class... params)`
`static java.lang.String` `prettyParams(java.lang.Class... params)`
`static java.lang.String` `prettyShortParams(java.lang.Class... params)`
`static java.lang.String` `sig(java.lang.Class[] retvalParams)`
`static java.lang.String` `sig(java.lang.Class retval, java.lang.Class... params)` Create a method signature from the given param types and return values
`static java.lang.String` `sig(java.lang.Class retval, java.lang.String descriptor, java.lang.Class... params)`
`static java.lang.String` `sigParams(java.lang.Class... params)`
`static java.lang.String` `sigParams(java.lang.String descriptor, java.lang.Class... params)`
`static void` `visitAnnotationFields(org.objectweb.asm.AnnotationVisitor visitor, java.util.Map<java.lang.String,java.lang.Object> fields)`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### CodegenUtils

    public CodegenUtils()

### Method Detail

#### c

    public static java.lang.String c(java.lang.String p)

Creates a dotted class name from a path/package name

#### p

    public static java.lang.String p(java.lang.Class n)

Creates a class path name, from a Class.

#### ci

    public static java.lang.String ci(java.lang.Class n)

Creates a class identifier of form Labc/abc;, from a Class.

#### human

    public static java.lang.String human(java.lang.Class n)

Creates a human-readable representation, from a Class.

#### humanShort

    public static java.lang.String humanShort(java.lang.Class n)

#### sig

    public static java.lang.String sig(java.lang.Class retval,
                                       java.lang.Class... params)

Create a method signature from the given param types and return values

#### sig

    public static java.lang.String sig(java.lang.Class[] retvalParams)

#### sig

    public static java.lang.String sig(java.lang.Class retval,
                                       java.lang.String descriptor,
                                       java.lang.Class... params)

#### sigParams

    public static java.lang.String sigParams(java.lang.Class... params)

#### sigParams

    public static java.lang.String sigParams(java.lang.String descriptor,
                                             java.lang.Class... params)

#### pretty

    public static java.lang.String pretty(java.lang.Class retval,
                                          java.lang.Class... params)

#### prettyParams

    public static java.lang.String prettyParams(java.lang.Class... params)

#### prettyShortParams

    public static java.lang.String prettyShortParams(java.lang.Class... params)

#### params

    public static java.lang.Class[] params(java.lang.Class... classes)

#### params

    public static java.lang.Class[] params(java.lang.Class cls,
                                           int times)

#### params

    public static java.lang.Class[] params(java.lang.Class cls1,
                                           java.lang.Class clsFill,
                                           int times)

#### params

    public static java.lang.Class[] params(java.lang.Class cls1,
                                           java.lang.Class cls2,
                                           java.lang.Class clsFill,
                                           int times)

#### getAnnotatedBindingClassName

    public static java.lang.String getAnnotatedBindingClassName(java.lang.String javaMethodName,
                                                                java.lang.String typeName,
                                                                boolean isStatic,
                                                                int required,
                                                                int optional,
                                                                boolean multi,
                                                                boolean framed)

#### visitAnnotationFields

    public static void visitAnnotationFields(org.objectweb.asm.AnnotationVisitor visitor,
                                             java.util.Map<java.lang.String,java.lang.Object> fields)

#### getBoxType

    public static java.lang.Class getBoxType(java.lang.Class type)